#include <stdio.h>
#include <string.h>

#define MMAX 1010
#define NMAX 1010
#define LMAX 29000

char linie[LMAX];
int A[MMAX][NMAX];
int hvert[NMAX], horiz[NMAX];
int stkcol[NMAX], stkh[NMAX], top;
int ycurr, wcurr, lastcurr, ytopcurr, dw, dx;
int i, j, k, p, M, N, maxarea, currarea, len;

void read_input(void)
{
	freopen("jmenoasa.in", "r", stdin);

	memset(linie, 0, sizeof(linie));
	fgets(linie, LMAX - 1, stdin);

	// get M and N
	p = 0;
	while (linie[p] < '0' || linie[p] > '9')
	{
		linie[p] = 0;
		p++;
	}

	M = 0;
	while (linie[p] >= '0' && linie[p] <= '9')
	{
		M = M * 10 + (linie[p] - '0');
		linie[p] = 0;
		p++;
	}

	while (linie[p] < '0' || linie[p] > '9')
	{
		linie[p] = 0;
		p++;
	}

	N = 0;
	while (linie[p] >= '0' && linie[p] <= '9')
	{
		N = N * 10 + (linie[p] - '0');
		linie[p] = 0;
		p++;
	}

	for (i = 1; i <= M; i++)
	{
		fgets(linie, LMAX - 1, stdin);

		p = 0;
		for (j = 1; j <= N; j++)
		{
			while (linie[p] < '0' || linie[p] > '9')
			{
				linie[p] = 0;
				p++;
			}

			k = 0;
			while (linie[p] >= '0' && linie[p] <= '9')
			{
				k = k * 10 + (linie[p] - '0');
				linie[p] = 0;
				p++;
			}

			A[i][j] = k;
		}
	}
}

void solve_row(int row)
{
	int cmax, to_insert;

	top = 0;

	for (j = N; j >= 0; j--)
	{
		// compute hvert
		if (j == 0)
			hvert[j] = 0;
		else
		if (row == 1)
			hvert[j] = 1;
		else
		{
			if (A[row][j] > A[row - 1][j])
				hvert[j] = hvert[j] + 1;
			else
				hvert[j] = 1;
		}
		
		// compute horiz
		if (j <= 1)
			horiz[j] = horiz[j] + 1;
		else
		{
			if (A[row][j] > A[row][j - 1])
				horiz[j] = horiz[j] + 1;
			else
				horiz[j] = 0;
		}

		if (horiz[j] > hvert[j])
			horiz[j] = hvert[j];

		// do stuff
		
		if (j == N)
		{
			if (hvert[j] > maxarea)
				maxarea = hvert[j];

			// update stack
			stkcol[1] = N;
			stkh[1] = horiz[N];
			top = 1;
		}
		else
		{
			// upate the stack (1)
			cmax = j;
			while (top > 0 && stkh[top] > hvert[j])
			{
				if (((stkcol[top] - j) * stkh[top]) > maxarea)
					maxarea = (stkcol[top] - j) * stkh[top];
				cmax = stkcol[top];
				top--;
			}

			if (hvert[j] * (cmax - j + 1) > maxarea)
				maxarea = hvert[j] * (cmax - j + 1);
			
			// update the stack (2)
			while (top > 0 && stkh[top] >= horiz[j])
			{
				if (((stkcol[top] - j) * stkh[top]) > maxarea)
					maxarea = (stkcol[top] - j) * stkh[top];

				if (hvert[j] >= stkh[top])
				{
					if (((stkcol[top] - j + 1) * stkh[top]) > maxarea)
						maxarea = (stkcol[top] - j + 1) * stkh[top];
				}

				cmax = stkcol[top];
				top--;
			}
			
			top++;
			stkcol[top] = cmax;
			stkh[top] = horiz[j];
		}
	}
}

int main()
{
	int row;

	read_input();

	maxarea = 1;
	for (row = 1; row <= M; row++)
		solve_row(row);

	freopen("jmenoasa.out", "w", stdout);
	printf("%d\n", maxarea);

	return 0;
}
