#include <stdio.h>
#include <string.h>

#define LMAX 5010
#define NMAX 5010
#define LCMAX 100
#define CMAX 28
#define HMAX 50021
#define PHASH 13
#define PMOD 666019

struct list_elem {
	int *p;
	int num;
	struct list_elem *next;
};

char S[LMAX], cuv[LMAX];
int cnt[NMAX][CMAX], mycnt[CMAX];
unsigned int npos[LMAX];
struct list_elem *hlist[HMAX];
int i, j, k, len, N, L, rez;

int hash(int *p)
{
	int j, h = 0;

	for (j = 0; j < CMAX; j++)
		h = (h * PHASH + p[j]) % HMAX;

	return h;
}

inline int test_equal(int *x, int *y)
{
	int j;

	for (j = 0; j < CMAX; j++)
		if (x[j] != y[j])
			return 0;

	return 1;
}

void add_to_hash(int i)
{
	struct list_elem *lnew, *ph;
	int found = 0;
	int h = hash((int*)(&cnt[i]));

	ph = hlist[h];

	while (ph != NULL)
	{
		if (test_equal(ph->p, (int*)(&cnt[i])))
		{
			ph->num++;
			found = 1;
			break;
		}

		ph = ph->next;
	}

	if (!found)
	{
		lnew = new struct list_elem;
		lnew->p = (int*)(&cnt[i]);
		lnew->num = 1;
		lnew->next = hlist[h];
		hlist[h] = lnew;
	}
}

inline int find_in_hash(void)
{
	struct list_elem* ph;
	int h = hash((int*)(&mycnt));

	ph = hlist[h];

	while (ph != NULL)
	{
		if (test_equal(ph->p, (int*)(&mycnt)))
			return ph->num;

		ph = ph->next;
	}

	return 0;
}

int main()
{
	freopen("propozitie2.in", "r", stdin);
	scanf("%s", S + 1);
	L = strlen(S + 1);

	scanf("%d", &N);

	memset(cnt, 0, sizeof(cnt));
	for (i = 0; i < HMAX; i++)
		hlist[i] = NULL;

	for (i = 1; i <= N; i++)
	{
		scanf("%s", cuv + 1);
		len = strlen(cuv + 1);

		for (j = 1; j <= len; j++)
			cnt[i][cuv[j] - 'a']++;

		add_to_hash(i);
	}

	npos[0] = 1;
	for (i = 1; i <= L; i++)
	{
		memset(mycnt, 0, sizeof(mycnt));

		npos[i] = 0;
		for (j = i; j >= i - LCMAX + 1 && j >= 1; j--)
		{
			mycnt[S[j] - 'a']++;
			rez = find_in_hash();
			
			npos[i] = (npos[i] + (npos[j - 1] * rez)) % PMOD;
		}
	}

	freopen("propozitie2.out", "w", stdout);
	printf("%u\n", npos[L]);

	return 0;
}
