#include <stdio.h>

#define NMAX 1048576
#define NMAXm1 1048575
#define BUFSIZE (16 * NMAX - 1)

char* buf;
long long Qaux[NMAX][2], Qin[NMAX];
long long Ctotal, L, l1, l2, INF;
int N, M, i, j, k, p, x, r;
int fQaux, lQaux, fQin, lQin, sizeQaux, nsel;

void read_data(void)
{
	// to save memory: use Qaux as a char buffer to speed up the reading of the input data
	buf = (char*) Qaux;

	fgets(buf, BUFSIZE - 1, stdin);
	sscanf(buf, "%d %d", &N, &M);

	fgets(buf, BUFSIZE - 1, stdin);

	// parse the line
	for (p = 0, i = 1; i <= N; i++)
	{
		x = 0;
		while (buf[p] < '0' || buf[p] > '9')
			p++;

		while (buf[p] >= '0' && buf[p] <= '9')
		{
			x = (x * 10) + (buf[p] - '0');
			p++;
		}

		Qin[i] = x;
	}
}

int main()
{
	freopen("scandura.in", "r", stdin);
	freopen("scandura.out", "w", stdout);

	read_data();

	INF = (long long) (2000000000) * (long long) (2000000);

	fQaux = 0; lQaux = NMAXm1;
	sizeQaux = 0;

	fQin = 1; lQin = N + 1;

	k = N / (M - 1);
	r = N % (M - 1);

	if (M > 2)
	{
		if (r == 0)
			x = M - 1;
		else
		if (r > 1)
			x = r;
		else
			x = M;
	}
	else
	{
		x = M;
	}
			

	while (sizeQaux != 1 || fQin != lQin)
	{
		// select the M smallest values, combined, from Qin and Qaux

		nsel = 0;
		L = Ctotal = 0;

		while (nsel < x)
		{		
			if (sizeQaux > 0)
				l1 = Qaux[fQaux][0];
			else
				l1 = INF;

			if (fQin != lQin)
				l2 = Qin[fQin];
			else
				l2 = INF;

			if (l1 <= l2 && l1 < INF)
			{
				L += l1;
				Ctotal += Qaux[fQaux][1];
				fQaux = (fQaux + 1) & NMAXm1;
				sizeQaux--;
			}
			else
			if (l2 <= l1 && l2 < INF)
			{
				L += l2;
				fQin++;
			}
			else
				break;

			nsel++;
		}

		// add the combined value to Qaux
		lQaux = (lQaux + 1) & NMAXm1;
		Qaux[lQaux][0] = L;
		Qaux[lQaux][1] = Ctotal + L;
		sizeQaux++;
		x = M;
	}

	printf("%lld\n", Qaux[lQaux][1]);

	return 0;
}
