#include <stdio.h>
#include <string.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 100100
#define TMAX 10100
#define LOGMAX 17

vector<pair<int, pair<int, int> > > v;
char marked[NMAX];
long long ndif[LOGMAX + 2], nextra[LOGMAX + 2];
char pmarked[NMAX * LOGMAX];
int lnotmarked[NMAX], nnotmarked;
long long ans[TMAX], cans;
int T;

void ciur(void)
{
	int i, j;

	memset(marked, 0, sizeof(marked));
	
	for (i = 2; i < NMAX; i++)
	{
		j = i;
		while (i <= (NMAX - 1) / j)
		{
			j *= i;

			/*
			if (marked[j] && !marked[i])
				fprintf(stderr, "i=%d, j=%d\n", i, j);
			*/

			marked[j] = 1;
		}
	}

	nnotmarked = 0;
	for (i = 2; i < NMAX; i++)
		if (!marked[i])
		{
			nnotmarked++;
			lnotmarked[nnotmarked] = i;
		}

	//fprintf(stderr, "not marked=%d\n", nnotmarked);
}

void readData(void)
{
	int i, j, k, N, M;

	freopen("jap.in", "r", stdin);
	scanf("%d", &T);

	v.clear();
	for (k = 1; k <= T; k++)
	{
		scanf("%d %d", &N, &M);
		v.push_back(make_pair(M, make_pair(N, k)));
	}

	sort(v.begin(), v.end());
}

void computeNdif(int M, int lastM)
{
	int i, j, q;
	char x;

	for (i = 0; i < LOGMAX; i++)
		/*ndif[i] =*/ nextra[i] = 0;

	//memset(pmarked, 0, sizeof(pmarked));

	for (i = 1; i < LOGMAX; i++)
	{
		for (j = lastM + 1; j <= M; j++)
		{
			q = i * j;
			x = pmarked[q];

			if (!x)
			{
				pmarked[q] = i;
				nextra[i]++;
			}
			else
			if (x > i)
			{
				nextra[i]++;
				nextra[x]--;
				pmarked[q] = i;
			}
		}
	}

	for (i = 1; i < LOGMAX; i++)
	{
		nextra[i] += nextra[i - 1];
		ndif[i] += nextra[i];
	}
}

void compute(void)
{
	int N, M, lastM = 0, NN, fpos, li, ls, mid, pok, i, j, k, q, q2;

	memset(pmarked, 0, sizeof(pmarked));

	for (k = 0; k < T; k++)
	{
		if (k == 0 || v[k].first > v[k - 1].first)
		{
			M = v[k].first;
			computeNdif(M, lastM);
			lastM = M;
		}

		N = v[k].second.first;
		cans = 1;

		for (fpos = 1, q = LOGMAX - 1; q >= 1; q--)
		{
			li = fpos; ls = nnotmarked;
			pok = fpos - 1;
			while (li <= ls)
			{
				mid = (li + ls) >> 1;

				// evaluate lnotmarked[mid]
				i = lnotmarked[mid];
				q2 = 0;
				NN = N;
				while (NN >= i)
				{
					q2++;
					NN /= i;
				}

				if (q2 < q)
					ls = mid - 1;
				else
					pok = mid, li = mid + 1;
			}

			cans += ndif[q] * (pok - fpos + 1);
			fpos = pok + 1;

			if (fpos > nnotmarked || lnotmarked[fpos] > N)
				break;
		}

		//fprintf(stderr, "M=%d, N=%d => %lld\n", M, N, cans);

		ans[v[k].second.second] = cans;
	}
}

void writeData(void)
{
	int i;

	freopen("jap.out", "w", stdout);
	for (i = 1; i <= T; i++)
		printf("%lld\n", ans[i]);
}

int main()
{
	ciur();
	readData();
	compute();
	writeData();
	return 0;
}
