#include <stdio.h>

#define NMAX 110000
#define LMAX 27
#define INF 1000000001
#define STK_STATE_ADVANCE 0
#define STK_STATE_WAITING_1 1
#define STK_STATE_WAITING_2 2

#define min(a,b) ((a) < (b) ? (a) : (b))
#define max(a,b) ((a) > (b) ? (a) : (b))

int C[NMAX], stk[NMAX][2], rez[NMAX][2][2];
char stkState[NMAX];
int A[LMAX][LMAX], rezaux[2][2];
char S[NMAX];
int i, j, k, N, M, niv;


int PQ[NMAX][2], bktState[NMAX], cbkt, ccur;
char bktaux;

void testBkt(int niv)
{
	if (niv > M)
	{
		for (ccur = 0, i = 2; i <= N; i++)
			ccur += A[S[i-1]][S[i]];
		cbkt = max(cbkt, ccur);
	}
	else
	{
		// switch
		bktaux = S[PQ[niv][0]];
		S[PQ[niv][0]] = S[PQ[niv][1]];
		S[PQ[niv][1]] = bktaux;

		testBkt(niv + 1);

		// perform the switch back
		bktaux = S[PQ[niv][0]];
		S[PQ[niv][0]] = S[PQ[niv][1]];
		S[PQ[niv][1]] = bktaux;

		testBkt(niv + 1);
	}
}


void readData(void)
{
	freopen("papuci.in", "r", stdin);

	scanf("%d %d", &N, &M);
	for (i = 1; i <= N; i++)
		C[i] = 0;

	scanf("%s", S + 1);
	S[0] = 0;

	for (i = 1; i < LMAX; i++)
		for (j = 1; j < LMAX; j++)
			scanf("%d", &A[i][j]);

	for (j = 0; j < LMAX; j++)
		A[0][j] = A[j][0] = 0;

	for (k = 0; k < M; k++)
	{
		scanf("%d %d", &i, &j);
		C[i] = j;
		C[j] = i;

		PQ[k + 1][0] = i;
		PQ[k + 1][1] = j;
	}

	C[0] = 0;

	for (i = 1; i <= N; i++)
	{
		S[i] = S[i] - 'a' + 1;

		if (!C[i])
			C[i] = i;
	}
}

void compute(void)
{
	int a, b, c, d, Caux;
	char ca, cb, cc, cd;

	/*
	cbkt = -INF;
	testBkt(1);
	fprintf(stderr, "backtracking solution: %d\n", cbkt);
	*/

	niv = 1;
	stk[niv][0] = 1;
	stk[niv][1] = N;
	stkState[niv] = STK_STATE_ADVANCE;
	rez[niv][0][0] = 0;
	rez[niv][0][1] = rez[niv][1][0] = rez[niv][1][1] = -INF;

	while (niv >= 1)
	{
		// fprintf(stderr, "[niv=%d, initial] range=[%d,%d], state=%d\n", niv, stk[niv][0], stk[niv][1], stkState[niv]);

		/*
		if (niv > N/2 + 1)
			fprintf(stderr, "!!!\n");
		*/

		if (stk[niv][0] > stk[niv][1])
			niv--;
		else
		if (stkState[niv] == STK_STATE_ADVANCE)
		{
			if (stk[niv][0] == stk[niv][1])
			{
				rez[niv][0][0] = rez[niv][1][1] = 0;
				rez[niv][0][1] = rez[niv][1][0] = -INF;

				// fprintf(stderr, "[niv=%d, final] range=[%d,%d], state=%d, rez(0,0)=%d, rez(0,1)=%d, rez(1,0)=%d, rez(1,1)=%d\n", niv, stk[niv][0], stk[niv][1], stkState[niv], rez[niv][0][0], rez[niv][0][1], rez[niv][1][0], rez[niv][1][1]);
				niv--;
			}
			else
			{
				if (C[stk[niv][0]] == stk[niv][1])
				{
					if (stk[niv][0] + 1 == C[stk[niv][0]])
					{
						// compute the cost directly
						rez[niv][0][0] = A[S[stk[niv][0]]][S[stk[niv][1]]];
						rez[niv][1][1] = A[S[stk[niv][1]]][S[stk[niv][0]]];
						rez[niv][0][1] = rez[niv][1][0] = -INF;

						// fprintf(stderr, "[niv=%d, final] range=[%d,%d], state=%d, rez(0,0)=%d, rez(0,1)=%d, rez(1,0)=%d, rez(1,1)=%d\n", niv, stk[niv][0], stk[niv][1], stkState[niv], rez[niv][0][0], rez[niv][0][1], rez[niv][1][0], rez[niv][1][1]);
						niv--;
					}
					else
					{
						stkState[niv] = STK_STATE_WAITING_1;
						niv++;
						stk[niv][0] = stk[niv - 1][0] + 1;
						stk[niv][1] = stk[niv - 1][1] - 1;
						stkState[niv] = STK_STATE_ADVANCE;
						rez[niv][0][0] = 0;
						rez[niv][0][1] = rez[niv][1][0] = rez[niv][1][1] = -INF;
					}
				}
				else
				{
					stkState[niv] = STK_STATE_WAITING_2;
					niv++;
					stk[niv][0] = stk[niv - 1][0];
					stk[niv][1] = C[stk[niv - 1][0]];
					stkState[niv] = STK_STATE_ADVANCE;
					rez[niv][0][0] = 0;
					rez[niv][0][1] = rez[niv][1][0] = rez[niv][1][1] = -INF;
				}
			}
		}
		else
		if (stkState[niv] == STK_STATE_WAITING_1)
		{
			rez[niv][0][1] = rez[niv][1][0] = -INF;

			// 1 - consider the case when we do not perform the switch
			rez[niv][0][0] = -INF;

			for (a = 0; a <= 1; a++)
				for (b = 0; b <= 1; b++)
				{
					if (a == 0)
						Caux = A[S[stk[niv][0]]][S[stk[niv + 1][0]]];
					else
						Caux = A[S[stk[niv][0]]][S[C[stk[niv + 1][0]]]];

					Caux += rez[niv + 1][a][b];

					if (b == 0)
						Caux += A[S[stk[niv + 1][1]]][S[stk[niv][1]]];
					else
						Caux += A[S[C[stk[niv + 1][1]]]][S[stk[niv][1]]];

					rez[niv][0][0] = max(rez[niv][0][0], Caux);
				}

			// 2 - consider the case when we perform the switch
			rez[niv][1][1] = -INF;

			for (a = 0; a <= 1; a++)
				for (b = 0; b <= 1; b++)
				{
					if (a == 0)
						Caux = A[S[stk[niv][1]]][S[stk[niv + 1][0]]];
					else
						Caux = A[S[stk[niv][1]]][S[C[stk[niv + 1][0]]]];

					Caux += rez[niv + 1][a][b];

					if (b == 0)
						Caux += A[S[stk[niv + 1][1]]][S[stk[niv][0]]];
					else
						Caux += A[S[C[stk[niv + 1][1]]]][S[stk[niv][0]]];

					rez[niv][1][1] = max(rez[niv][1][1], Caux);
				}

			// fprintf(stderr, "[niv=%d, final] range=[%d,%d], state=%d, rez(0,0)=%d, rez(0,1)=%d, rez(1,0)=%d, rez(1,1)=%d\n", niv, stk[niv][0], stk[niv][1], stkState[niv], rez[niv][0][0], rez[niv][0][1], rez[niv][1][0], rez[niv][1][1]);
			niv--;
		}
		else // stkState[niv] = STK_STATE_WAITING_2
		{
			rezaux[0][0] = rezaux[0][1] = rezaux[1][0] = rezaux[1][1] = -INF;

			for (a = 0; a <= 1; a++)
				for (b = 0; b <= 1; b++)
					for (c = 0; c <= 1; c++)
						for (d = 0; d <= 1; d++)
						{
							if (stk[niv + 1][0] == stk[niv][0] && (a != c || b != d))
								continue;

							if (b == 0)
								cb = S[stk[niv + 1][0] - 1];
							else
								cb = S[C[stk[niv + 1][0] - 1]];

							if (c == 0)
								cc = S[stk[niv + 1][0]];
							else
								cc = S[C[stk[niv + 1][0]]];

							if (stk[niv + 1][0] > stk[niv][0])
								Caux = rez[niv][a][b] + A[cb][cc] + rez[niv + 1][c][d];
							else
								Caux = rez[niv + 1][c][d];

							rezaux[a][d] = max(rezaux[a][d], Caux);
						}

			for (a = 0; a <= 1; a++)
				for (b = 0; b <= 1; b++)
					rez[niv][a][b] = rezaux[a][b];

			// fprintf(stderr, "[niv=%d, partial] range=[%d,%d], state=%d, rez(0,0)=%d, rez(0,1)=%d, rez(1,0)=%d, rez(1,1)=%d\n", niv, stk[niv][0], stk[niv][1], stkState[niv], rez[niv][0][0], rez[niv][0][1], rez[niv][1][0], rez[niv][1][1]);

			if (stk[niv + 1][1] < stk[niv][1])
			{
				stkState[niv] = STK_STATE_WAITING_2;
				niv++;
				stk[niv][0] = stk[niv][1] + 1;
				stk[niv][1] = stk[niv - 1][1];
				stkState[niv] = STK_STATE_ADVANCE;
				rez[niv][0][0] = 0;
				rez[niv][0][1] = rez[niv][1][0] = rez[niv][1][1] = -INF;
			}
			else
			{
				// fprintf(stderr, "[niv=%d, final] range=[%d,%d], state=%d, rez(0,0)=%d, rez(0,1)=%d, rez(1,0)=%d, rez(1,1)=%d\n", niv, stk[niv][0], stk[niv][1], stkState[niv], rez[niv][0][0], rez[niv][0][1], rez[niv][1][0], rez[niv][1][1]);
				niv--;
			}
		}
	}
}

void writeData(void)
{
	int a, b, vmax = -INF;

	freopen("papuci.out", "w", stdout);
	
	for (a = 0; a <= 1; a++)
		for (b = 0; b <= 1; b++)
			vmax = max(vmax, rez[1][a][b]);

	printf("%d\n", vmax);
}

int main()
{
	readData();
	compute();
	writeData();
	return 0;
}
