// O(N+M) (using lists with lazy deletion -- implemented as vectors)

#include <stdio.h>
#include <string.h>
#include<vector>

using namespace std;

#define NMAX 100010
#define BUFMAX 1000

vector<int> v[NMAX], lst[NMAX];
int deg[NMAX], cpoz[NMAX];
char out[NMAX], buf[BUFMAX + 5];
int N, M, dmax, nmax;

void readData(void)
{
	int x, p, i, j;

	freopen("gminmax.in", "r", stdin);
	fgets(buf, BUFMAX, stdin);

	p = x = 0;
	while (buf[p] < '0' || buf[p] > '9') p++;

	while (buf[p] >= '0' && buf[p] <= '9')
	{
		x = (x * 10) + (buf[p] - '0');
		p++;
	}

	N = x;

	x = 0;
	while (buf[p] < '0' || buf[p] > '9') p++;

	while (buf[p] >= '0' && buf[p] <= '9')
	{
		x = (x * 10) + (buf[p] - '0');
		p++;
	}

	M = x;

	while (M--)
	{
		fgets(buf, BUFMAX, stdin);

		p = x = 0;
		while (buf[p] < '0' || buf[p] > '9') p++;

		while (buf[p] >= '0' && buf[p] <= '9')
		{
			x = (x * 10) + (buf[p] - '0');
			p++;
		}

		i = x;

		x = 0;
		while (buf[p] < '0' || buf[p] > '9') p++;

		while (buf[p] >= '0' && buf[p] <= '9')
		{
			x = (x * 10) + (buf[p] - '0');
			p++;
		}

		j = x;

		v[i].push_back(j);
		v[j].push_back(i);
	}
}

void compute(void)
{
	int degmin = N, nleft, found, cv, i, k, x;

	memset(out, 0, sizeof(out));
	memset(deg, 0, sizeof(deg));
	memset(cpoz, 0, sizeof(cpoz));

	for (i = 1; i <= N; i++)
	{
		deg[i] = v[i].size();
		lst[deg[i]].push_back(i);

		if (deg[i] < degmin) degmin = deg[i];
	}

	dmax = degmin;
	nmax = nleft = N;

	while (nleft >= 1)
	{
		found = 0;
		while (!found)
		{
			if (cpoz[degmin] < lst[degmin].size())
			{
				cv = lst[degmin][cpoz[degmin]];
				if (deg[cv] == degmin && !out[cv])
					found = 1;
				else
					cpoz[degmin]++;
			}
			else
				degmin++;
		}

		if (degmin > dmax)
		{
			dmax = degmin;
			nmax = nleft;
		}

		for (k = 0; k < v[cv].size(); k++)
		{
			x = v[cv][k];
			if (!out[x])
			{
				deg[x]--;
				lst[deg[x]].push_back(x);
			}
		}

		nleft--;

		deg[cv] = 0;
		out[cv] = 1;

		if (degmin > 0)
			degmin--;
	}
}

void writeData(void)
{
	freopen("gminmax.out", "w", stdout);
	printf("%d %d\n", dmax, nmax);
}

int main()
{
	readData();
	compute();
	writeData();

	return 0;
}