// O(N^3)

#include <stdio.h>
#include <math.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 300

vector<pair<int, int> > v;
vector<pair<long double, int> > v2;
int o[NMAX][NMAX], poz[NMAX][NMAX], below[NMAX], above[NMAX];
int x[NMAX], y[NMAX], xpoz[NMAX], processed[NMAX], cand[NMAX];
int i, j, k, l, p, q, r, N, nq, nbelow, nabove, ncand;
long long a, b, c, d;

void readData(void)
{
	freopen("patrulatere.in", "r", stdin);
	scanf("%d", &N);

	for (i = 0; i < N; i++)
		scanf("%d %d", &x[i], &y[i]);
}

void compute(void)
{
	for (i = 0; i < N; i++)
	{
		v.push_back(make_pair(x[i], i));

		v2.clear();
		for (j = 0; j < N; j++)
			if (j != i)
				v2.push_back(make_pair(atan2((long double) (y[j] - y[i]), (long double) (x[j] - x[i])), j));

		sort(v2.begin(), v2.end());
		for (j = 0; j < N - 1; j++)
		{
			o[i][j] = v2[j].second;
			poz[i][o[i][j]] = j;
		}
	}

	sort(v.begin(), v.end());

	for (q = 0; q < N; q++)
		xpoz[v[q].second] = q;

	// process the points in increasing order of their x-coordinates

	for (nq = 0, q = 0; q < N; q++)
	{
		p = v[q].second;

		// consider all the quadrilaterals with a corner at p and with the other corners at x-coordinates > x[p]

		/*
		v2.clear();
		for (j = q + 1; j < N; j++)
			v2.push_back(make_pair(atan2((long double) (y[v[j].second] - y[p]), (long double) (x[v[j].second] - x[p])), v[j].second));

		sort(v2.begin(), v2.end());
		*/

		ncand = 0;
		for (j = 0; j < N; j++)
			if (xpoz[o[p][j]] > q)
			{
				cand[ncand] = o[p][j];
				ncand++;
			}

		memset(processed, 0, sizeof(processed));

		for (j = 0; j < ncand /*< v2.size()*/; j++)
		{
			r = cand[j] /*v2[j].second*/;

			// compute how many segments cross the segment (p,r)

			nbelow = nabove = 0;

			for (k = (poz[r][p] + 1) % (N - 1); k != poz[r][p]; k = (k + 1) % (N - 1))
				if (xpoz[o[r][k]] > q && processed[o[r][k]])
				{
					nbelow++;
					below[nbelow] = o[r][k];
				}
				else
				if (xpoz[o[r][k]] > q && !processed[o[r][k]])
				{
					nabove++;
					above[nabove] = o[r][k];
				}

			for (k = l = 1; k <= nbelow; k++)
			{
				a = y[below[k]] - y[r];
				b = x[r] - x[below[k]];
				c = (long long) x[below[k]] * (long long) y[r] - (long long) x[r] * (long long) y[below[k]];

				while (l <= nabove)
				{
					d = a * x[above[l]] + b * y[above[l]] + c;
					
					if (d < 0)
						l++;
					else
						break;
				}

				nq += (nabove - l + 1);
			}

			processed[r] = 1;
		}
	}
}

void writeData(void)
{
	freopen("patrulatere.out", "w", stdout);
	printf("%d\n", nq);
}

int main()
{
	readData();
	compute();
	writeData();

	return 0;
}
