#include <stdio.h>
//#include <time.h>
#include <vector>
#include <algorithm>
using namespace std;

#define RMAX 100010
#define NMAX 301
#define QMAX 100100
#define INF 666666666

#define vmin(a,b) ((a) <= (b) ? (a) : (b))

vector<pair<int, int> > vr;
vector<pair<int, int> > ve[NMAX];
//vector<pair<int, pair<int, int> > > vq[RMAX];
vector<pair<int, pair<int, pair<int, int> > > > vq;

int r[NMAX], rridx[NMAX], D[NMAX][NMAX], qans[QMAX];
int i, j, k, p, e, l, N, M, Q, ridx, qidx, x;

void solve()
{
	// initialize the distances
	for (i = 1; i <= N; i++)
	{
		for (j = 1; j <= N; j++)
			D[i][j] = INF;

		D[i][i] = 0;

		for (j = ve[i].size() - 1; j >= 0; j--)
			D[i][ve[i][j].first] = vmin(D[i][ve[i][j].first], ve[i][j].second);
	}

	ridx = 0;
	qidx = 0;

	while (1)
	{
		/*
		while (vq[qidx].size() == 0 && qidx < RMAX)
			qidx++;

		if (qidx == RMAX)
			break;
		*/

		if (qidx == Q)
			break;

		if (ridx < N && vr[ridx].first <= vq[qidx].first)
		{
			p = vr[ridx].second;

			/*
			for (k = ve[p].size() - 1; k >= 0; k--)
			{
				j = ve[p][k].first;
				l = ve[p][k].second;

				if (rridx[j] > ridx)
					continue;

				for (i = 1; i <= N; i++)
					D[p][i] = D[i][p] = vmin(D[i][p], D[i][j] + l);
			}
			*/

			for (i = 1; i <= N; i++)
				for (j = i + 1; j <= N; j++)
				{
					x = D[i][p] + D[p][j];
					D[i][j] = D[j][i] = vmin(D[i][j], x);
				}

			ridx++;
		}
		else
		{
			/*
			for (k = vq[qidx].size() - 1; k >= 0; k--)
				qans[vq[qidx][k].first] = D[vq[qidx][k].second.first][vq[qidx][k].second.second];
			*/

			qans[vq[qidx].second.first] = D[vq[qidx].second.second.first][vq[qidx].second.second.second];

			qidx++;
		}
	}
}

#define LINESIZE 5000
char line[LINESIZE];

void readInput()
{
	int p;

	freopen("risc.in", "r", stdin);

	//scanf("%d %d %d", &N, &M, &Q);
	fgets(line, LINESIZE - 2, stdin);
	for (p = 0; line[p] < '0' || line[p] > '9'; p++);
	N = 0;
	for (; line[p] >= '0' && line[p] <= '9'; p++)
		N = N * 10 + (line[p] - '0');
	for (; line[p] < '0' || line[p] > '9'; p++);
	M = 0;
	for (; line[p] >= '0' && line[p] <= '9'; p++)
		M = M * 10 + (line[p] - '0');
	for (; line[p] < '0' || line[p] > '9'; p++);
	Q = 0;
	for (; line[p] >= '0' && line[p] <= '9'; p++)
		Q = Q * 10 + (line[p] - '0');

	// read the risk values

	fgets(line, LINESIZE - 2, stdin);
	p = 0;
	for (i = 1; i <= N; i++)
	{
		//scanf("%d", &r[i]);
		for (; line[p] < '0' || line[p] > '9'; p++);
		r[i] = 0;
		for (; line[p] >= '0' && line[p] <= '9'; p++)
			r[i] = r[i] * 10 + (line[p] - '0');

		vr.push_back(make_pair(r[i], i));
	}

	// read the edges
	for (e = 1; e <= M; e++)
	{
		//scanf("%d %d %d", &i, &j, &k);
		fgets(line, LINESIZE - 2, stdin);
		for (p = 0; line[p] < '0' || line[p] > '9'; p++);
		i = 0;
		for (; line[p] >= '0' && line[p] <= '9'; p++)
			i = i * 10 + (line[p] - '0');
		for (; line[p] < '0' || line[p] > '9'; p++);
		j = 0;
		for (; line[p] >= '0' && line[p] <= '9'; p++)
			j = j * 10 + (line[p] - '0');
		for (; line[p] < '0' || line[p] > '9'; p++);
		k = 0;
		for (; line[p] >= '0' && line[p] <= '9'; p++)
			k = k * 10 + (line[p] - '0');
		
		ve[i].push_back(make_pair(j, k));
		ve[j].push_back(make_pair(i, k));
	}

	// read the queries
	for (e = 1; e <= Q; e++)
	{
		//scanf("%d %d %d", &i, &j, &k);
		fgets(line, LINESIZE - 2, stdin);
		for (p = 0; line[p] < '0' || line[p] > '9'; p++);
		i = 0;
		for (; line[p] >= '0' && line[p] <= '9'; p++)
			i = i * 10 + (line[p] - '0');
		for (; line[p] < '0' || line[p] > '9'; p++);
		j = 0;
		for (; line[p] >= '0' && line[p] <= '9'; p++)
			j = j * 10 + (line[p] - '0');
		for (; line[p] < '0' || line[p] > '9'; p++);
		k = 0;
		for (; line[p] >= '0' && line[p] <= '9'; p++)
			k = k * 10 + (line[p] - '0');
		
		//vq[k].push_back(make_pair(p, make_pair(i, j)));
		vq.push_back(make_pair(k, make_pair(e, make_pair(i, j))));
	}
}

int main()
{
	//int tstart = clock();

	readInput();
	//fprintf(stderr, "Reading input data duration = %.3lf sec\n", ((double) (clock() - tstart)) / CLOCKS_PER_SEC);

	sort(vr.begin(), vr.end());
	for (i = 0; i < N; i++)
		rridx[vr[i].second] = i;

	sort(vq.begin(), vq.end());

	solve();

	freopen("risc.out", "w", stdout);
	for (i = 1; i <= Q; i++)
	{
		if (qans[i] == INF)
			printf("-1\n");
		else
			printf("%d\n", qans[i]);
	}

	//fprintf(stderr, "Duration = %.3lf sec\n", ((double) (clock() - tstart)) / CLOCKS_PER_SEC);

	return 0;
}