#include <stdio.h>
#include <string.h>

#define BMAX 31
#define PMOD 666013

long long A, B, C, X1, X2, T[8][8], rez[8][8], newrez[8][8], vinit[8], finalrez;
int N, pw2[BMAX];

/* Matricea de iteratie arata dupa cum urmeaza:

X(i)             | A B   0 0 0 0 0 C |   | X(i-1)             |
X(i-1)           | 1 0   0 0 0 0 0 0 |   | X(i-2)             |
i                | 0 0   1 0 0 0 0 1 |   | i-1                |
i*C           =  | 0 0   0 1 0 0 0 C | * | (i-1)*C            |
i*X(i)           | A 2*B 0 1 A B 0 C |   | (i-1)*X(i-1)       |
(i-1)*X(i-1)     | 0 0   0 0 1 0 0 0 |   | (i-2)*X(i-2)       |
Suma(i*X(i))     | A 2*B 0 1 A B 1 C |   | Suma((i-1)*X(i-1)) |
1                | 0 0   0 0 0 0 0 1 |   | 1                  |
*/

void constructT(void)
{
	memset(T, 0, sizeof(T));
	T[0][0] = A % PMOD; T[0][1] = B % PMOD; T[0][7] = C % PMOD;
	T[1][0] = 1;
	T[2][2] = 1; T[2][7] = 1;
	T[3][3] = 1; T[3][7] = C % PMOD;
	T[4][0] = A % PMOD; T[4][1] = (2*B) % PMOD; T[4][3] = 1; T[4][4] = A % PMOD; T[4][5] = B % PMOD; T[4][7] = C % PMOD;
	T[5][4] = 1;
	T[6][0] = A % PMOD; T[6][1] = (2*B) % PMOD; T[6][3] = 1; T[6][4] = A % PMOD; T[6][5] = B % PMOD; T[6][6] = 1; T[6][7] = C % PMOD;
	T[7][7] = 1;
}

void raiseToPower(int P)
{
	int i, j, k, q;

	pw2[0] = 1;
	for (i = 1; i < BMAX; i++)
		pw2[i] = pw2[i - 1] * 2;

	memset(rez, 0, sizeof(rez));
	for (i = 0; i < 8; i++)
		rez[i][i] = 1;

	for (q = BMAX - 1; q >= 0; q--)
	{
		memset(newrez, 0, sizeof(newrez));
		for (i = 0; i < 8; i++)
			for (j = 0; j < 8; j++)
				for (k = 0; k < 8; k++)
					newrez[i][j] = (newrez[i][j] + rez[i][k] * rez[k][j]) % PMOD;

		memmove(rez, newrez, sizeof(newrez));

		if ((P & pw2[q]) > 0)
		{
			memset(newrez, 0, sizeof(newrez));
			for (i = 0; i < 8; i++)
				for (j = 0; j < 8; j++)
					for (k = 0; k < 8; k++)
						newrez[i][j] = (newrez[i][j] + rez[i][k] * T[k][j]) % PMOD;

			memmove(rez, newrez, sizeof(newrez));
		}
	}
}

int main()
{
	int i;

	freopen("recurenta2.in", "r", stdin);
	scanf("%lld %lld %lld %lld %lld %d", &A, &B, &C, &X1, &X2, &N);

	constructT();
	raiseToPower(N - 2);

	vinit[0] = X2;
	vinit[1] = X1;
	vinit[2] = 2;
	vinit[3] = (2 * C) % PMOD;
	vinit[4] = (2 * X2) % PMOD;
	vinit[5] = 1 * X1;
	vinit[6] = (2 * X2 + 1 * X1) % PMOD;
	vinit[7] = 1;

	finalrez = 0;
	for (i = 0; i < 8; i++)
		finalrez = (finalrez + rez[6][i] * vinit[i]) % PMOD;

	freopen("recurenta2.out", "w", stdout);
	printf("%lld\n", finalrez);

	return 0;
}
