#include <stdio.h>
#include <string.h>
#include <vector>
#include <time.h>

using namespace std;

#define NMAX 1000001
#define HASHMAX 2097152

int key[HASHMAX], cnt[HASHMAX];
int v[NMAX], t[NMAX], sv[NMAX], firstSon[NMAX], lastSon[NMAX], nextSon[NMAX];
int stk[NMAX], cson[NMAX];
int i, j, k, N, S, niv, minValue, maxValue;
long long npaths;

void readInput(void)
{
	freopen("arbore3.in", "r", stdin);
	scanf("%d %d", &N, &S);

	memset(firstSon, 0, sizeof(firstSon));

	for (i = 1; i <= N; i++)
	{
		scanf("%d %d", &t[i], &v[i]);

		if (t[i] != 0)
		{
			if (!firstSon[t[i]])
			{
				firstSon[t[i]] = lastSon[t[i]] = i;
			}
			else
			{
				nextSon[lastSon[t[i]]] = i;
				lastSon[t[i]] = i;
			}
		}
	}
}

#define NUMBITS 21
unsigned int h, BITMASK = 0;

void initHash(void)
{
	memset(cnt, 0, sizeof(cnt));

	for (k = 0; k < NUMBITS; k++)
		BITMASK |= (1 << k);
}

#define hash2(val) ( (((((unsigned int)val) & BITMASK) >> 10) | ((((unsigned int)val) << 11) & BITMASK)) ^ (((unsigned int) val) >> NUMBITS) )

#define hash(val) ( (((unsigned int) val) * 1000004791) & BITMASK )

void insertIntoHash(int val)
{
	h = hash(val);
	for (k = h; cnt[k] > 0 && key[k] != val; k = (k + 1) & BITMASK);
	key[k] = val;
	cnt[k]++;
}

void removeFromHash(int val)
{
	h = hash(val);
	for (k = h; cnt[k] > 0 && key[k] != val; k = (k + 1) & BITMASK);
	//if (cnt[k] > 0)
	cnt[k]--;
}

int queryHash(int val)
{
	h = hash(val);
	for (k = h; cnt[k] > 0 && key[k] != val; k = (k + 1) & BITMASK);
	return cnt[k];
}

void compute(void)
{
	initHash();

	minValue = -1;
	for (i = 1; i <= 31; i++)
		minValue *= 2;

	maxValue = 0;
	for (i = 0; i <= 30; i++)
		maxValue |= (1 << i);

	npaths = 0;

	niv = 1;
	stk[niv] = 1;
	cson[niv] = firstSon[1];
	sv[1] = 0;

	while (niv >= 1)
	{
		i = stk[niv];

		if (cson[niv] == firstSon[stk[niv]])
		{
			// entering the node i

			if (t[i] > 0)
				sv[i] = sv[t[i]] + v[t[i]];

			// insert into hash
			insertIntoHash(sv[i]);

			// query the hash
			if ((S >= 0 && minValue + S <= sv[i] + v[i]) ||
				(S < 0 && sv[i] + v[i] <= maxValue + S))
				npaths += queryHash(sv[i] + v[i] - S);
		}

		if (cson[niv] <= 0)
		{
			// exiting the node i

			// remove from the hash
			removeFromHash(sv[i]);

			niv--;
		}
		else
		{
			// push the next son on the stack
			niv++;
			stk[niv] = cson[niv - 1];
			cson[niv] = firstSon[stk[niv]];

			if (cson[niv - 1] == lastSon[i])
				cson[niv - 1] = 0;
			else
				cson[niv - 1] = nextSon[cson[niv - 1]];
		}
	}
}

void writeOutput(void)
{
	freopen("arbore3.out", "w", stdout);
	printf("%lld\n", npaths);
	fprintf(stderr, "%lld\n", npaths);
}

int main()
{
	int tstart = clock();

	readInput();
	compute();
	writeOutput();

	fprintf(stderr, "Duration=%.4lf sec\n", (double) (clock() - tstart) / CLOCKS_PER_SEC);

	return 0;
}
